import React, { useState } from 'react';
import SuiSwitch from '@s-ui/react-atom-switch';
import IconAccordion from '../iconAccordion';
export default function TcfSecondLayerUserDecision(_ref) {
  var onConsentChange = _ref.onConsentChange,
      onLegitimateInterestChange = _ref.onLegitimateInterestChange,
      baseClass = _ref.baseClass,
      info = _ref.info,
      consentValue = _ref.consentValue,
      legitimateInterestValue = _ref.legitimateInterestValue,
      _ref$hasConsent = _ref.hasConsent,
      hasConsent = _ref$hasConsent === void 0 ? true : _ref$hasConsent,
      _ref$hasLegitimateInt = _ref.hasLegitimateInterest,
      hasLegitimateInterest = _ref$hasLegitimateInt === void 0 ? true : _ref$hasLegitimateInt,
      vendorList = _ref.vendorList,
      i18n = _ref.i18n;

  var _useState = useState(false),
      expanded = _useState[0],
      setExpanded = _useState[1];

  var handleItemClick = function handleItemClick() {
    setExpanded(!expanded);
  };

  var PolicyUrl = function PolicyUrl() {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("h3", null, i18n.VENDOR_PAGE.GROUPS.EXPANDED.POLICY_URL), /*#__PURE__*/React.createElement("a", {
      className: baseClass + "-text " + baseClass + "-text--expanded",
      href: info.policyUrl,
      target: "_blank",
      rel: "noopener noreferrer"
    }, info.policyUrl));
  };

  var Information = function Information(_ref2) {
    var ids = _ref2.ids,
        vendorList = _ref2.vendorList;
    return ids.map(function (id) {
      var _vendorList$id, _vendorList$id2;

      return /*#__PURE__*/React.createElement("div", {
        key: id + "-purposes",
        className: baseClass + "-paragraph"
      }, /*#__PURE__*/React.createElement("p", {
        className: baseClass + "-text " + baseClass + "-text--expanded"
      }, /*#__PURE__*/React.createElement("strong", null, vendorList && ((_vendorList$id = vendorList[id]) == null ? void 0 : _vendorList$id.name) + ": ")), /*#__PURE__*/React.createElement("p", {
        className: baseClass + "-text " + baseClass + "-text--expanded"
      }, vendorList && ((_vendorList$id2 = vendorList[id]) == null ? void 0 : _vendorList$id2.description)));
    });
  };

  var ExpandedContent = function ExpandedContent() {
    var _info$purposes, _info$purposes2, _info$legIntPurposes, _info$specialPurposes, _info$specialPurposes2, _info$features, _info$features2, _info$specialFeatures, _info$specialFeatures2;

    return /*#__PURE__*/React.createElement(React.Fragment, null, info.policyUrl && /*#__PURE__*/React.createElement(PolicyUrl, null), !!((_info$purposes = info.purposes) == null ? void 0 : _info$purposes.length) && vendorList.purposes && /*#__PURE__*/React.createElement("h3", null, i18n.VENDOR_PAGE.GROUPS.EXPANDED.PURPOSES), !!((_info$purposes2 = info.purposes) == null ? void 0 : _info$purposes2.length) && vendorList.purposes && /*#__PURE__*/React.createElement(Information, {
      ids: info.purposes,
      vendorList: vendorList.purposes
    }), !!info.legIntPurposes.length && vendorList.purposes && /*#__PURE__*/React.createElement("h3", null, i18n.VENDOR_PAGE.GROUPS.EXPANDED.LEGITIMATE_INTEREST_PURPOSES), !!((_info$legIntPurposes = info.legIntPurposes) == null ? void 0 : _info$legIntPurposes.length) && vendorList.purposes && /*#__PURE__*/React.createElement(Information, {
      ids: info.legIntPurposes,
      vendorList: vendorList.purposes
    }), !!((_info$specialPurposes = info.specialPurposes) == null ? void 0 : _info$specialPurposes.length) && vendorList.specialPurposes && /*#__PURE__*/React.createElement("h3", null, i18n.VENDOR_PAGE.GROUPS.EXPANDED.SPECIAL_PURPOSES), !!((_info$specialPurposes2 = info.specialPurposes) == null ? void 0 : _info$specialPurposes2.length) && vendorList.specialPurposes && /*#__PURE__*/React.createElement(Information, {
      ids: info.specialPurposes,
      vendorList: vendorList.specialPurposes
    }), !!((_info$features = info.features) == null ? void 0 : _info$features.length) && vendorList.features && /*#__PURE__*/React.createElement("h3", null, i18n.VENDOR_PAGE.GROUPS.EXPANDED.FEATURES), !!((_info$features2 = info.features) == null ? void 0 : _info$features2.length) && vendorList.features && /*#__PURE__*/React.createElement(Information, {
      ids: info.features,
      vendorList: vendorList.features
    }), !!((_info$specialFeatures = info.specialFeatures) == null ? void 0 : _info$specialFeatures.length) && vendorList.specialFeatures && /*#__PURE__*/React.createElement("h3", null, i18n.VENDOR_PAGE.GROUPS.EXPANDED.SPECIAL_FEATURES), !!((_info$specialFeatures2 = info.specialFeatures) == null ? void 0 : _info$specialFeatures2.length) && vendorList.specialFeatures && /*#__PURE__*/React.createElement(Information, {
      ids: info.specialFeatures,
      vendorList: vendorList.specialFeatures
    }));
  };

  var Switchs = function Switchs() {
    return /*#__PURE__*/React.createElement("div", {
      className: baseClass + "-switchs"
    }, hasConsent && /*#__PURE__*/React.createElement(SuiSwitch, {
      type: "single",
      name: "groupItem",
      value: consentValue,
      label: i18n.CONSENT_COPY,
      onToggle: function onToggle() {
        return onConsentChange(consentValue);
      }
    }), hasLegitimateInterest && /*#__PURE__*/React.createElement(SuiSwitch, {
      type: "single",
      name: "groupItem",
      value: legitimateInterestValue,
      label: i18n.LEGITIMATE_INTEREST_COPY,
      onToggle: function onToggle() {
        return onLegitimateInterestChange(legitimateInterestValue);
      }
    }));
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-container"
  }, /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-container-clicklable",
    onClick: handleItemClick
  }, /*#__PURE__*/React.createElement(IconAccordion, {
    baseClass: expanded ? baseClass + "-icon-accordion " + baseClass + "-icon-accordion--expanded" : baseClass + "-icon-accordion"
  }), /*#__PURE__*/React.createElement("p", {
    className: baseClass + "-text"
  }, info.name)), hasConsent || hasLegitimateInterest ? /*#__PURE__*/React.createElement(Switchs, null) : null), expanded && /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-container--expanded"
  }, /*#__PURE__*/React.createElement(ExpandedContent, null)));
}
TcfSecondLayerUserDecision.defaultProps = {
  hasConsent: true,
  hasLegitimateInterest: true
};